'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LayoutWizard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ = require('../');

var _Wizard = require('../../Wizard');

var _Wizard2 = _interopRequireDefault(_Wizard);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LayoutWizard = exports.LayoutWizard = function (_Component) {
  _inherits(LayoutWizard, _Component);

  function LayoutWizard() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, LayoutWizard);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = LayoutWizard.__proto__ || Object.getPrototypeOf(LayoutWizard)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      currentStep: _this.props.initialStepIndex
    }, _this.isControlled = _this.props.currentStep !== undefined, _this.handleChangeStep = function (newStep) {
      var onStepChange = _this.props.onStepChange;

      onStepChange && onStepChange(newStep);

      if (!_this.isControlled) {
        _this.setState({ currentStep: newStep });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(LayoutWizard, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          currentStepProp = _props.currentStep,
          headerExtra = _props.headerExtra,
          initialStepIndex = _props.initialStepIndex,
          onStepChange = _props.onStepChange,
          mainContentProps = _props.mainContentProps,
          steps = _props.steps,
          otherProps = _objectWithoutProperties(_props, ['children', 'className', 'currentStep', 'headerExtra', 'initialStepIndex', 'onStepChange', 'mainContentProps', 'steps']);

      var currentStep = this.isControlled ? currentStepProp : this.state.currentStep;
      var classes = (0, _classnames2.default)('inloco-layout__wizard', className);
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(
          _.Layout.Header,
          null,
          _react2.default.createElement(
            _.Layout.HeaderTitle,
            null,
            _react2.default.createElement(
              'div',
              { className: 'inloco-layout__wizard-title' },
              _react2.default.createElement(
                'div',
                { className: 'inloco-layout__wizard-title-number' },
                currentStep + 1
              ),
              steps[currentStep]
            )
          ),
          headerExtra && _react2.default.createElement(
            _.Layout.HeaderControls,
            null,
            headerExtra
          )
        ),
        _react2.default.createElement(
          _.Layout.MainContent,
          mainContentProps,
          _react2.default.createElement(
            _Wizard2.default,
            _extends({
              className: classes,
              currentStep: currentStep,
              steps: steps,
              onChangeStep: this.handleChangeStep
            }, otherProps),
            children
          )
        )
      );
    }
  }]);

  return LayoutWizard;
}(_react.Component);

LayoutWizard.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node.isRequired,
  currentStep: _propTypes2.default.number,
  headerExtra: _propTypes2.default.node,
  initialStepIndex: _propTypes2.default.number,
  mainContentProps: _propTypes2.default.object,
  onStepChange: _propTypes2.default.func,
  steps: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired
};
LayoutWizard.defaultProps = {
  initialStepIndex: 0,
  mainContentProps: {}
};
exports.default = LayoutWizard;